---
title: async function
slug: Web/JavaScript/Reference/Statements/async_function
tags:
  - Example
  - Function
  - JavaScript
  - Language feature
  - Statement
---
<div>{{jsSidebar("Statements")}}</div>

<p><span class="seoSummary">An async function is a function declared with the <code>async</code><strong> </strong>keyword<strong>. </strong>Async functions are instances of the {{jsxref("Global_Objects/AsyncFunction","AsyncFunction")}} constructor, and the <code>await</code> keyword is permitted within them. The <code>async</code> and <code>await</code> keywords enable asynchronous, promise-based behavior to be written in a cleaner style, avoiding the need to explicitly configure promise chains.</span></p>

<p>Async functions may also be defined {{jsxref("Operators/async_function", "as expressions", "", 1)}}.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-async.html", "taller")}}</div>

<div class="hidden">The source for this interactive demo is stored in a GitHub repository. If you'd like to contribute to the interactive demo project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">async function <var>name</var>([<var>param</var>[, <var>param</var>[, ...<var>param</var>]]]) {
   <var>statements</var>
}
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>name</var></code></dt>
 <dd>The function’s name.</dd>
 <dt><code><var>param</var></code></dt>
 <dd>The name of an argument to be passed to the function.</dd>
 <dt><code><var>statements</var></code></dt>
 <dd>The statements comprising the body of the function.  The <code>await</code> mechanism may be used.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which will be resolved with the value returned by the async function, or rejected with an exception thrown from, or uncaught within, the async function.</p>

<h2 id="Description">Description</h2>

<p>Async functions can contain zero or more {{jsxref("Operators/await", "await")}} expressions. Await expressions suspend progress through an async function, yielding control and subsequently resuming progress only when an awaited promise-based asynchronous operation is either fulfilled or rejected. The resolved value of the promise is treated as the return value of the await expression. Use of <code>async</code> / <code>await</code> enables the use of ordinary <code>try</code> / <code>catch</code> blocks around asynchronous code.</p>

<div class="note">
<p>The <code>await</code> keyword is only valid inside async functions. If you use it outside of an async function's body, you will get a {{jsxref("SyntaxError")}}.</p>
</div>

<div class="note">
<p>The purpose of <code>async</code>/<code>await</code> is to simplify the syntax necessary to consume promise-based APIs. The behavior of <code>async</code>/<code>await</code> is similar to combining <a href="/en-US/docs/Web/JavaScript/Guide/Iterators_and_Generators">generators</a> and promises.</p>
</div>

<p>Async functions always return a promise. If the return value of an async function is not explicitly a promise, it will be implicitly wrapped in a promise.</p>

<p>For example, the following:</p>

<pre class="syntaxbox notranslate">async function <var>foo</var>() {
   <var>return 1</var>
}
</pre>

<p>...is equivalent to:</p>

<pre class="syntaxbox notranslate">function <var>foo</var>() {
   <var>return Promise.resolve(1)</var>
}
</pre>

<p>The body of an async function can be thought of as being split by zero or more await expressions. Top-level code, up to and including the first await expression (if there is one), is run synchronously. In this way, an async function without an await expression will run synchronously. If there is an await expression inside the function body, however, the async function will always complete asynchronously.</p>

<p>For example:</p>

<pre class="syntaxbox notranslate">async function <var>foo</var>() {
   <var>await 1</var>
}
</pre>

<p>...is equivalent to:</p>

<pre class="syntaxbox notranslate">function <var>foo</var>() {
   <var>return Promise.resolve(1).then(() =&gt; undefined)</var>
}
</pre>

<p>Code after each await expression can be thought of as existing in a <code>.then</code> callback. In this way a promise chain is progressively constructed with each reentrant step through the function. The return value forms the final link in the chain.</p>

<p>In the following example, we successively await two promises. Progress moves through function <code>foo</code> in three stages.</p>

<ol>
 <li>The first line of the body of function <code>foo</code> is executed synchronously, with the await expression configured with the pending promise. Progress through <code>foo</code> is then suspended and control is yielded back to the function that called <code>foo</code>.</li>
 <li>Some time later, when the first promise has either been fulfilled or rejected, control moves back into <code>foo</code>. The result of the first promise fulfilment (if it was not rejected) is returned from the await expression. Here <code>1</code> is assigned to <code>result1</code>. Progress continues, and the second await expression is evaluated. Again, progress through <code>foo</code> is suspended and control is yielded.</li>
 <li>Some time later, when the second promise has either been fulfilled or rejected, control re-enters <code>foo</code>. The result of the second promise resolution is returned from the second await expression. Here <code>2</code> is assigned to <code>result2</code>. Control moves to the return expression (if any). The default return value of <code>undefined</code> is returned as the resolution value of the current promise.</li>
</ol>

<pre class="syntaxbox notranslate">async function <var>foo</var>() {
   const result1 = <var>await new Promise((resolve) =&gt; setTimeout(() =&gt; resolve('1')))
</var>   const result2 = <var>await new Promise((resolve) =&gt; setTimeout(() =&gt; resolve('2')))</var>
}
foo()</pre>

<p>Note how the promise chain is not built-up in one go. Instead, the promise chain is constructed in stages as control is successively yielded from and returned to the async function. As a result, we must be mindful of error handling behavior when dealing with concurrent asynchronous operations.</p>

<p>For example, in the following code an unhandled promise rejection error will be thrown, even if a <code>.catch</code> handler has been configured further along the promise chain. This is because <code>p2</code> will not be "wired into" the promise chain until control returns from <code>p1</code>.</p>

<pre class="syntaxbox notranslate">async function <var>foo</var>() {
   const p1 = <var>new Promise((resolve) =&gt; setTimeout(() =&gt; resolve('1'), 1000))
</var>   const p2 = <var>new Promise((_,reject) =&gt; setTimeout(() =&gt; reject('2'), 500))
   const results = [await p1, await p2] // Do not do this! Use Promise.all or Promise.allSettled instead.</var>
}
foo().catch(() =&gt; {}) // Attempt to swallow all errors...
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Async_functions_and_execution_order">Async functions and execution order</h3>

<pre class="brush: js notranslate">function resolveAfter2Seconds() {
  console.log("starting slow promise")
  return new Promise(resolve =&gt; {
    setTimeout(function() {
      resolve("slow")
      console.log("slow promise is done")
    }, 2000)
  })
}

function resolveAfter1Second() {
  console.log("starting fast promise")
  return new Promise(resolve =&gt; {
    setTimeout(function() {
      resolve("fast")
      console.log("fast promise is done")
    }, 1000)
  })
}

async function sequentialStart() {
  console.log('==SEQUENTIAL START==')

  // 1. Execution gets here almost instantly
  const slow = await resolveAfter2Seconds()
  console.log(slow) // 2. this runs 2 seconds after 1.

  const fast = await resolveAfter1Second()
  console.log(fast) // 3. this runs 3 seconds after 1.
}

async function concurrentStart() {
  console.log('==CONCURRENT START with await==');
  const slow = resolveAfter2Seconds() // starts timer immediately
  const fast = resolveAfter1Second() // starts timer immediately

  // 1. Execution gets here almost instantly
  console.log(await slow) // 2. this runs 2 seconds after 1.
  console.log(await fast) // 3. this runs 2 seconds after 1., immediately after 2., since fast is already resolved
}

function concurrentPromise() {
  console.log('==CONCURRENT START with Promise.all==')
  return Promise.all([resolveAfter2Seconds(), resolveAfter1Second()]).then((messages) =&gt; {
    console.log(messages[0]) // slow
    console.log(messages[1]) // fast
  })
}

async function parallel() {
  console.log('==PARALLEL with await Promise.all==')

  // Start 2 "jobs" in parallel and wait for both of them to complete
  await Promise.all([
      (async()=&gt;console.log(await resolveAfter2Seconds()))(),
      (async()=&gt;console.log(await resolveAfter1Second()))()
  ])
}

sequentialStart() // after 2 seconds, logs "slow", then after 1 more second, "fast"

// wait above to finish
setTimeout(concurrentStart, 4000) // after 2 seconds, logs "slow" and then "fast"

// wait again
setTimeout(concurrentPromise, 7000) // same as concurrentStart

// wait again
setTimeout(parallel, 10000) // truly parallel: after 1 second, logs "fast", then after 1 more second, "slow"
</pre>

<h4 id="await_and_parallelism">await and parallelism</h4>

<p>In <code>sequentialStart</code>, execution suspends 2 seconds for the first <code>await</code>, and then another second for the second <code>await</code>. The second timer is not created until the first has already fired, so the code finishes after 3 seconds.</p>

<p>In <code>concurrentStart</code>, both timers are created and then <code>await</code>ed. The timers run concurrently, which means the code finishes in 2 rather than 3 seconds, i.e. the slowest timer.<br>
 However, the <code>await</code> calls still run in series, which means the second <code>await</code> will wait for the first one to finish. In this case, the result of the fastest timer is processed after the slowest.</p>

<p>If you wish to safely perform two or more jobs in parallel, you must await a call to <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/all">Promise.all</a></code>, or <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise/allSettled">Promise.allSettled</a></code>.</p>

<div class="warning">
<h4 id="Error_Handling">Error Handling</h4>

<p>Note that functions <code>concurrentStart</code> and <code>concurrentPromise</code> are not functionally equivalent.</p>

<p>In <code>concurrentStart</code>, if promise <code>fast</code> rejects before promise <code>slow</code> is fulfilled, then an unhandled promise rejection error will be raised, regardless of whether the caller has configured a catch clause.</p>

<p>In <code>concurrentPromise,</code> <code>Promise.all</code> wires up the promise chain in one go, meaning that the operation will fail-fast regardless of the order of rejection of the promises, and the error will always occur within the configured promise chain, enabling it to be caught in the normal way.</p>
</div>

<h3 id="Rewriting_a_Promise_chain_with_an_async_function">Rewriting a Promise chain with an async function</h3>

<p>An API that returns a {{jsxref("Promise")}} will result in a promise chain, and it splits the function into many parts. Consider the following code:</p>

<pre class="brush: js notranslate">function getProcessedData(url) {
  return downloadData(url) // returns a promise
    .catch(e =&gt; {
      return downloadFallbackData(url)  // returns a promise
    })
    .then(v =&gt; {
      return processDataInWorker(v)  // returns a promise
    })
}
</pre>

<p>it can be rewritten with a single async function as follows:</p>

<pre class="brush: js notranslate">async function getProcessedData(url) {
  let v
  try {
    v = await downloadData(url)
  } catch(e) {
    v = await downloadFallbackData(url)
  }
  return processDataInWorker(v)
}
</pre>

<p>In the above example, notice there is no <code>await</code> statement after the <code>return</code> keyword, although that would be valid too: The return value of an <code>async function</code> is implicitly wrapped in {{jsxref("Promise.resolve")}} - if it's not already a promise itself (as in this example).</p>

<div class="notecard note">
<h4 id="return_await_promiseValue_vs._return_promiseValue">return await promiseValue vs. return promiseValue</h4>

<p>The implicit wrapping of return values in {{jsxref("Promise.resolve")}} does not imply that <code>return await promiseValue</code> is functionally equivalent to <code>return promiseValue</code>.</p>

<p>Consider the following rewrite of the above code. It returns <code>null</code> if <code>processDataInWorker</code> rejects with an error:</p>

<pre class="brush: js notranslate">async function getProcessedData(url) {
  let v
  try {
    v = await downloadData(url)
  } catch(e) {
    v = await downloadFallbackData(url)
  }
  try {
    return await processDataInWorker(v)  // Note the `return await` vs. just `return`
  } catch (e) {
    return null
  }
}
</pre>

<p>Writing <code>return processDataInWorker(v)</code> would have caused the {{jsxref("Promise")}} returned by the function to reject, instead of resolving to <code>null</code> if <code>processDataInWorker(v)</code> rejects.</p>

<p>This highlights the subtle difference between <code>return foo;</code> and <code>return await foo;</code> — <code>return foo</code> immediately returns <code>foo</code> and never throws, even if <code>foo</code> is a Promise that rejects. <code>return await foo</code> will <em>wait </em>for <code>foo</code> to resolve or reject if it's a Promise, and throws <strong>before returning</strong> if it rejects.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-async-function-definitions', 'async function')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.statements.async_function")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Operators/async_function", "async function expression")}}</li>
 <li>{{jsxref("AsyncFunction")}} object</li>
 <li>{{jsxref("Operators/await", "await")}}</li>
 <li><a href="http://innolitics.com/10x/javascript-decorators-for-promise-returning-functions/">"Decorating Async Javascript Functions" on "innolitics.com"</a></li>
</ul>
